Index: /trunk/sources/HeuristicLab.Visualization/HeuristicLab.Visualization.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/HeuristicLab.Visualization.csproj	(revision 1336)
+++ /trunk/sources/HeuristicLab.Visualization/HeuristicLab.Visualization.csproj	(revision 1337)
@@ -100,4 +100,5 @@
       <DependentUpon>OptionsDialog.cs</DependentUpon>
     </Compile>
+    <Compile Include="Options\ViewPropertiesModel.cs" />
     <Compile Include="PanListener.cs" />
     <Compile Include="LabelProvider\StringLabelProvider.cs" />
Index: /trunk/sources/HeuristicLab.Visualization/Legend/LegendShape.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/Legend/LegendShape.cs	(revision 1336)
+++ /trunk/sources/HeuristicLab.Visualization/Legend/LegendShape.cs	(revision 1337)
@@ -1,9 +1,12 @@
 using System.Collections.Generic;
-using HeuristicLab.Visualization.Legend;
+using System.Drawing;
 
 namespace HeuristicLab.Visualization.Legend {
   public class LegendShape : WorldShape {
     private readonly IList<LegendItem> legendItems = new List<LegendItem>();
-    
+
+    private Color color = Color.Blue;
+    private Font font = new Font("Arial", 8);
+
     public LegendShape() {
       CreateLegend();
@@ -15,5 +18,5 @@
       foreach (LegendItem item in legendItems) {
         AddShape(new LineShape(10, y - 10, 30, y - 10, item.Color, item.Thickness, DrawingStyle.Solid));
-        AddShape(new TextShape(35, y, item.Label));
+        AddShape(new TextShape(35, y, item.Label, font, color));
         y -= 15;
       }
@@ -31,4 +34,31 @@
       legendItems.Clear();
     }
+
+    public Color Color {
+      get { return color; }
+      set {
+        color = value;
+        UpdateTextShapes();
+      }
+    }
+
+    public Font Font {
+      get { return font; }
+      set {
+        font = value;
+        UpdateTextShapes();
+      }
+    }
+
+    private void UpdateTextShapes() {
+      foreach (IShape shape in shapes) {
+        TextShape textShape = shape as TextShape;
+
+        if (textShape != null) {
+          textShape.Font = font;
+          textShape.Color = color;
+        }
+      }
+    }
   }
 }
Index: /trunk/sources/HeuristicLab.Visualization/LineChart.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/LineChart.cs	(revision 1336)
+++ /trunk/sources/HeuristicLab.Visualization/LineChart.cs	(revision 1337)
@@ -29,4 +29,6 @@
     private bool zoomToFullView;
 
+    private readonly ViewPropertiesModel viewPropertiesModel;
+
     /// <summary>
     /// This constructor shouldn't be called. Only required for the designer.
@@ -34,12 +36,4 @@
     public LineChart() {
       InitializeComponent();
-    }
-
-    public TextShape Title {
-      get { return titleShape; }
-    }
-
-    public LegendShape Legend {
-      get { return legendShape; }
     }
 
@@ -56,4 +50,6 @@
 
       this.model = model;
+      viewPropertiesModel = new ViewPropertiesModel(titleShape.Font, titleShape.Color, legendShape.Font, legendShape.Color, xAxis.Font, xAxis.Color);
+      viewPropertiesModel.OnUpdateProperties += UpdateViewProperties;
 
       Item = model;
@@ -63,4 +59,17 @@
 
       ZoomToFullView();
+    }
+
+    private void UpdateViewProperties() {
+      titleShape.Font = viewPropertiesModel.TitleFont;
+      titleShape.Color = viewPropertiesModel.TitleColor;
+
+      legendShape.Font = viewPropertiesModel.LegendFont;
+      legendShape.Color = viewPropertiesModel.LegendColor;
+
+      xAxis.Font = viewPropertiesModel.XAxisFont;
+      xAxis.Color = viewPropertiesModel.XAxisColor;
+
+      canvasUI.Invalidate();
     }
 
@@ -136,5 +145,5 @@
 
     private void optionsToolStripMenuItem_Click(object sender, EventArgs e) {
-      OptionsDialog optionsdlg = new OptionsDialog(this.model, this);
+      OptionsDialog optionsdlg = new OptionsDialog(this.model, viewPropertiesModel);
       optionsdlg.ShowDialog(this);
     }
Index: /trunk/sources/HeuristicLab.Visualization/Options/OptionsDialog.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/Options/OptionsDialog.Designer.cs	(revision 1336)
+++ /trunk/sources/HeuristicLab.Visualization/Options/OptionsDialog.Designer.cs	(revision 1337)
@@ -31,19 +31,21 @@
       this.btnChangeTitleFont = new System.Windows.Forms.Button();
       this.tabPage2 = new System.Windows.Forms.TabPage();
+      this.btnChangeLegendFont = new System.Windows.Forms.Button();
+      this.labelposition = new System.Windows.Forms.Label();
       this.cbLabelPosition = new System.Windows.Forms.ComboBox();
-      this.labelposition = new System.Windows.Forms.Label();
       this.tabPage1 = new System.Windows.Forms.TabPage();
+      this.OptionsDialogSelectColorBt = new System.Windows.Forms.Button();
+      this.ColorPreviewTB = new System.Windows.Forms.TextBox();
+      this.label2 = new System.Windows.Forms.Label();
+      this.LinestyleCB = new System.Windows.Forms.ComboBox();
+      this.label1 = new System.Windows.Forms.Label();
+      this.LineSelectCB = new System.Windows.Forms.ComboBox();
       this.groupBox1 = new System.Windows.Forms.GroupBox();
+      this.label4 = new System.Windows.Forms.Label();
+      this.LineThicknessCB = new System.Windows.Forms.ComboBox();
       this.label3 = new System.Windows.Forms.Label();
-      this.LineThicknessCB = new System.Windows.Forms.ComboBox();
-      this.label4 = new System.Windows.Forms.Label();
-      this.LineSelectCB = new System.Windows.Forms.ComboBox();
-      this.label1 = new System.Windows.Forms.Label();
-      this.LinestyleCB = new System.Windows.Forms.ComboBox();
-      this.label2 = new System.Windows.Forms.Label();
-      this.ColorPreviewTB = new System.Windows.Forms.TextBox();
-      this.OptionsDialogSelectColorBt = new System.Windows.Forms.Button();
       this.Optionstabs = new System.Windows.Forms.TabControl();
-      this.btnChangeLegendFont = new System.Windows.Forms.Button();
+      this.tpXAxis = new System.Windows.Forms.TabPage();
+      this.btnChangeXAxisFont = new System.Windows.Forms.Button();
       this.tpTitle.SuspendLayout();
       this.tabPage2.SuspendLayout();
@@ -51,4 +53,5 @@
       this.groupBox1.SuspendLayout();
       this.Optionstabs.SuspendLayout();
+      this.tpXAxis.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -119,4 +122,23 @@
       this.tabPage2.Text = "Legend";
       this.tabPage2.UseVisualStyleBackColor = true;
+      // 
+      // btnChangeLegendFont
+      // 
+      this.btnChangeLegendFont.Location = new System.Drawing.Point(3, 6);
+      this.btnChangeLegendFont.Name = "btnChangeLegendFont";
+      this.btnChangeLegendFont.Size = new System.Drawing.Size(94, 23);
+      this.btnChangeLegendFont.TabIndex = 2;
+      this.btnChangeLegendFont.Text = "Change Font";
+      this.btnChangeLegendFont.UseVisualStyleBackColor = true;
+      this.btnChangeLegendFont.Click += new System.EventHandler(this.btnChangeLegendFont_Click);
+      // 
+      // labelposition
+      // 
+      this.labelposition.AutoSize = true;
+      this.labelposition.Location = new System.Drawing.Point(3, 47);
+      this.labelposition.Name = "labelposition";
+      this.labelposition.Size = new System.Drawing.Size(72, 13);
+      this.labelposition.TabIndex = 1;
+      this.labelposition.Text = "Labelposition:";
       // 
       // cbLabelPosition
@@ -133,13 +155,4 @@
       this.cbLabelPosition.Size = new System.Drawing.Size(121, 21);
       this.cbLabelPosition.TabIndex = 0;
-      // 
-      // labelposition
-      // 
-      this.labelposition.AutoSize = true;
-      this.labelposition.Location = new System.Drawing.Point(3, 47);
-      this.labelposition.Name = "labelposition";
-      this.labelposition.Size = new System.Drawing.Size(72, 13);
-      this.labelposition.TabIndex = 1;
-      this.labelposition.Text = "Labelposition:";
       // 
       // tabPage1
@@ -160,4 +173,59 @@
       this.tabPage1.UseVisualStyleBackColor = true;
       // 
+      // OptionsDialogSelectColorBt
+      // 
+      this.OptionsDialogSelectColorBt.Location = new System.Drawing.Point(217, 126);
+      this.OptionsDialogSelectColorBt.Name = "OptionsDialogSelectColorBt";
+      this.OptionsDialogSelectColorBt.Size = new System.Drawing.Size(50, 23);
+      this.OptionsDialogSelectColorBt.TabIndex = 7;
+      this.OptionsDialogSelectColorBt.Text = "Select";
+      this.OptionsDialogSelectColorBt.UseVisualStyleBackColor = true;
+      this.OptionsDialogSelectColorBt.Click += new System.EventHandler(this.OptionsDialogSelectColorBtn_Click);
+      // 
+      // ColorPreviewTB
+      // 
+      this.ColorPreviewTB.Location = new System.Drawing.Point(146, 127);
+      this.ColorPreviewTB.Name = "ColorPreviewTB";
+      this.ColorPreviewTB.ReadOnly = true;
+      this.ColorPreviewTB.Size = new System.Drawing.Size(64, 20);
+      this.ColorPreviewTB.TabIndex = 6;
+      // 
+      // label2
+      // 
+      this.label2.AutoSize = true;
+      this.label2.Location = new System.Drawing.Point(36, 80);
+      this.label2.Name = "label2";
+      this.label2.Size = new System.Drawing.Size(30, 13);
+      this.label2.TabIndex = 3;
+      this.label2.Text = "Style";
+      // 
+      // LinestyleCB
+      // 
+      this.LinestyleCB.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.LinestyleCB.FormattingEnabled = true;
+      this.LinestyleCB.Location = new System.Drawing.Point(146, 73);
+      this.LinestyleCB.Name = "LinestyleCB";
+      this.LinestyleCB.Size = new System.Drawing.Size(121, 21);
+      this.LinestyleCB.TabIndex = 2;
+      // 
+      // label1
+      // 
+      this.label1.AutoSize = true;
+      this.label1.Location = new System.Drawing.Point(7, 37);
+      this.label1.Name = "label1";
+      this.label1.Size = new System.Drawing.Size(72, 13);
+      this.label1.TabIndex = 1;
+      this.label1.Text = "Selected Line";
+      // 
+      // LineSelectCB
+      // 
+      this.LineSelectCB.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.LineSelectCB.FormattingEnabled = true;
+      this.LineSelectCB.Location = new System.Drawing.Point(146, 30);
+      this.LineSelectCB.Name = "LineSelectCB";
+      this.LineSelectCB.Size = new System.Drawing.Size(121, 21);
+      this.LineSelectCB.TabIndex = 0;
+      this.LineSelectCB.SelectedIndexChanged += new System.EventHandler(this.LineSelectCB_SelectedIndexChanged);
+      // 
       // groupBox1
       // 
@@ -172,4 +240,22 @@
       this.groupBox1.Text = "Details";
       // 
+      // label4
+      // 
+      this.label4.AutoSize = true;
+      this.label4.Location = new System.Drawing.Point(33, 77);
+      this.label4.Name = "label4";
+      this.label4.Size = new System.Drawing.Size(31, 13);
+      this.label4.TabIndex = 8;
+      this.label4.Text = "Color";
+      // 
+      // LineThicknessCB
+      // 
+      this.LineThicknessCB.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.LineThicknessCB.FormattingEnabled = true;
+      this.LineThicknessCB.Location = new System.Drawing.Point(142, 46);
+      this.LineThicknessCB.Name = "LineThicknessCB";
+      this.LineThicknessCB.Size = new System.Drawing.Size(121, 21);
+      this.LineThicknessCB.TabIndex = 4;
+      // 
       // label3
       // 
@@ -181,77 +267,4 @@
       this.label3.Text = "Thickness";
       // 
-      // LineThicknessCB
-      // 
-      this.LineThicknessCB.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.LineThicknessCB.FormattingEnabled = true;
-      this.LineThicknessCB.Location = new System.Drawing.Point(142, 46);
-      this.LineThicknessCB.Name = "LineThicknessCB";
-      this.LineThicknessCB.Size = new System.Drawing.Size(121, 21);
-      this.LineThicknessCB.TabIndex = 4;
-      // 
-      // label4
-      // 
-      this.label4.AutoSize = true;
-      this.label4.Location = new System.Drawing.Point(33, 77);
-      this.label4.Name = "label4";
-      this.label4.Size = new System.Drawing.Size(31, 13);
-      this.label4.TabIndex = 8;
-      this.label4.Text = "Color";
-      // 
-      // LineSelectCB
-      // 
-      this.LineSelectCB.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.LineSelectCB.FormattingEnabled = true;
-      this.LineSelectCB.Location = new System.Drawing.Point(146, 30);
-      this.LineSelectCB.Name = "LineSelectCB";
-      this.LineSelectCB.Size = new System.Drawing.Size(121, 21);
-      this.LineSelectCB.TabIndex = 0;
-      this.LineSelectCB.SelectedIndexChanged += new System.EventHandler(this.LineSelectCB_SelectedIndexChanged);
-      // 
-      // label1
-      // 
-      this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(7, 37);
-      this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(72, 13);
-      this.label1.TabIndex = 1;
-      this.label1.Text = "Selected Line";
-      // 
-      // LinestyleCB
-      // 
-      this.LinestyleCB.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.LinestyleCB.FormattingEnabled = true;
-      this.LinestyleCB.Location = new System.Drawing.Point(146, 73);
-      this.LinestyleCB.Name = "LinestyleCB";
-      this.LinestyleCB.Size = new System.Drawing.Size(121, 21);
-      this.LinestyleCB.TabIndex = 2;
-      // 
-      // label2
-      // 
-      this.label2.AutoSize = true;
-      this.label2.Location = new System.Drawing.Point(36, 80);
-      this.label2.Name = "label2";
-      this.label2.Size = new System.Drawing.Size(30, 13);
-      this.label2.TabIndex = 3;
-      this.label2.Text = "Style";
-      // 
-      // ColorPreviewTB
-      // 
-      this.ColorPreviewTB.Location = new System.Drawing.Point(146, 127);
-      this.ColorPreviewTB.Name = "ColorPreviewTB";
-      this.ColorPreviewTB.ReadOnly = true;
-      this.ColorPreviewTB.Size = new System.Drawing.Size(64, 20);
-      this.ColorPreviewTB.TabIndex = 6;
-      // 
-      // OptionsDialogSelectColorBt
-      // 
-      this.OptionsDialogSelectColorBt.Location = new System.Drawing.Point(217, 126);
-      this.OptionsDialogSelectColorBt.Name = "OptionsDialogSelectColorBt";
-      this.OptionsDialogSelectColorBt.Size = new System.Drawing.Size(50, 23);
-      this.OptionsDialogSelectColorBt.TabIndex = 7;
-      this.OptionsDialogSelectColorBt.Text = "Select";
-      this.OptionsDialogSelectColorBt.UseVisualStyleBackColor = true;
-      this.OptionsDialogSelectColorBt.Click += new System.EventHandler(this.OptionsDialogSelectColorBtn_Click);
-      // 
       // Optionstabs
       // 
@@ -259,4 +272,5 @@
       this.Optionstabs.Controls.Add(this.tabPage2);
       this.Optionstabs.Controls.Add(this.tpTitle);
+      this.Optionstabs.Controls.Add(this.tpXAxis);
       this.Optionstabs.Location = new System.Drawing.Point(0, 1);
       this.Optionstabs.Name = "Optionstabs";
@@ -265,13 +279,23 @@
       this.Optionstabs.TabIndex = 0;
       // 
-      // btnChangeLegendFont
-      // 
-      this.btnChangeLegendFont.Location = new System.Drawing.Point(3, 6);
-      this.btnChangeLegendFont.Name = "btnChangeLegendFont";
-      this.btnChangeLegendFont.Size = new System.Drawing.Size(94, 23);
-      this.btnChangeLegendFont.TabIndex = 2;
-      this.btnChangeLegendFont.Text = "Change Font";
-      this.btnChangeLegendFont.UseVisualStyleBackColor = true;
-      this.btnChangeLegendFont.Click += new System.EventHandler(this.btnChangeLegendFont_Click);
+      // tpXAxis
+      // 
+      this.tpXAxis.Controls.Add(this.btnChangeXAxisFont);
+      this.tpXAxis.Location = new System.Drawing.Point(4, 22);
+      this.tpXAxis.Name = "tpXAxis";
+      this.tpXAxis.Size = new System.Drawing.Size(284, 199);
+      this.tpXAxis.TabIndex = 3;
+      this.tpXAxis.Text = "X-Axis";
+      this.tpXAxis.UseVisualStyleBackColor = true;
+      // 
+      // btnChangeXAxisFont
+      // 
+      this.btnChangeXAxisFont.Location = new System.Drawing.Point(3, 3);
+      this.btnChangeXAxisFont.Name = "btnChangeXAxisFont";
+      this.btnChangeXAxisFont.Size = new System.Drawing.Size(94, 23);
+      this.btnChangeXAxisFont.TabIndex = 2;
+      this.btnChangeXAxisFont.Text = "Change Font";
+      this.btnChangeXAxisFont.UseVisualStyleBackColor = true;
+      this.btnChangeXAxisFont.Click += new System.EventHandler(this.btnChangeXAxisFont_Click);
       // 
       // OptionsDialog
@@ -297,4 +321,5 @@
       this.groupBox1.PerformLayout();
       this.Optionstabs.ResumeLayout(false);
+      this.tpXAxis.ResumeLayout(false);
       this.ResumeLayout(false);
 
@@ -325,4 +350,6 @@
     private System.Windows.Forms.TabControl Optionstabs;
     private System.Windows.Forms.Button btnChangeLegendFont;
+    private System.Windows.Forms.TabPage tpXAxis;
+    private System.Windows.Forms.Button btnChangeXAxisFont;
   }
 }
Index: /trunk/sources/HeuristicLab.Visualization/Options/OptionsDialog.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/Options/OptionsDialog.cs	(revision 1336)
+++ /trunk/sources/HeuristicLab.Visualization/Options/OptionsDialog.cs	(revision 1337)
@@ -6,10 +6,11 @@
   public partial class OptionsDialog : Form {
     private readonly IChartDataRowsModel model;
-    private readonly LineChart lineChart;
+    private readonly ViewPropertiesModel propertiesModel;
 
-    public OptionsDialog(IChartDataRowsModel model, LineChart lineChart) {
+    public OptionsDialog(IChartDataRowsModel model, ViewPropertiesModel propertiesModel) {
       InitializeComponent();
+
       this.model = model;
-      this.lineChart = lineChart;
+      this.propertiesModel = propertiesModel;
     }
 
@@ -71,29 +72,45 @@
         ((IDataRow)LineSelectCB.SelectedValue).Style = (DrawingStyle)LinestyleCB.SelectedItem;
       }
-
-      lineChart.Invalidate(true);
     }
 
     private void btnChangeTitleFont_Click(object sender, EventArgs e) {
-      fdFont.Font = lineChart.Title.Font;
-      fdFont.Color = lineChart.Title.Color;
+      fdFont.Font = propertiesModel.TitleFont;
+      fdFont.Color = propertiesModel.TitleColor;
 
       DialogResult dr = fdFont.ShowDialog();
 
       if(dr == DialogResult.OK) {
-        lineChart.Title.Font = fdFont.Font;
-        lineChart.Title.Color = fdFont.Color;
+        propertiesModel.TitleFont = fdFont.Font;
+        propertiesModel.TitleColor = fdFont.Color;
+
+        propertiesModel.UpdateView();
       }
     }
 
     private void btnChangeLegendFont_Click(object sender, EventArgs e) {
-//      fdFont.Font = lineChart.Legend.Font;
-//      fdFont.Color = lineChart.Legend.Color;
+      fdFont.Font = propertiesModel.LegendFont;
+      fdFont.Color = propertiesModel.LegendColor;
 
       DialogResult dr = fdFont.ShowDialog();
 
       if (dr == DialogResult.OK) {
-//        lineChart.Legend.Font = fdFont.Font;
-//        lineChart.Legend.Color = fdFont.Color;
+        propertiesModel.LegendFont = fdFont.Font;
+        propertiesModel.LegendColor = fdFont.Color;
+
+        propertiesModel.UpdateView();
+      }
+    }
+
+    private void btnChangeXAxisFont_Click(object sender, EventArgs e) {
+      fdFont.Font = propertiesModel.XAxisFont;
+      fdFont.Color = propertiesModel.XAxisColor;
+
+      DialogResult dr = fdFont.ShowDialog();
+
+      if (dr == DialogResult.OK) {
+        propertiesModel.XAxisFont = fdFont.Font;
+        propertiesModel.XAxisColor = fdFont.Color;
+
+        propertiesModel.UpdateView();
       }
     }
Index: /trunk/sources/HeuristicLab.Visualization/Options/ViewPropertiesModel.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/Options/ViewPropertiesModel.cs	(revision 1337)
+++ /trunk/sources/HeuristicLab.Visualization/Options/ViewPropertiesModel.cs	(revision 1337)
@@ -0,0 +1,61 @@
+using System.Drawing;
+
+namespace HeuristicLab.Visualization.Options {
+  public class ViewPropertiesModel {
+    public event UpdatePropertiesHandler OnUpdateProperties;
+
+    private Font titleFont;
+    private Color titleColor;
+    private Font legendFont;
+    private Color legendColor;
+    private Font xAxisFont;
+    private Color xAxisColor;
+
+    public ViewPropertiesModel(Font titleFont, Color titleColor, Font legendFont, Color legendColor, Font xAxisFont, Color xAxisColor) {
+      this.titleFont = titleFont;
+      this.titleColor = titleColor;
+      this.legendFont = legendFont;
+      this.legendColor = legendColor;
+      this.xAxisFont = xAxisFont;
+      this.xAxisColor = xAxisColor;
+    }
+
+    public void UpdateView() {
+      if (OnUpdateProperties != null) {
+        OnUpdateProperties();
+      }
+    }
+
+    public Font TitleFont {
+      get { return titleFont; }
+      set { titleFont = value; }
+    }
+
+    public Color TitleColor {
+      get { return titleColor; }
+      set { titleColor = value; }
+    }
+
+    public Font LegendFont {
+      get { return legendFont; }
+      set { legendFont = value; }
+    }
+
+    public Color LegendColor {
+      get { return legendColor; }
+      set { legendColor = value; }
+    }
+
+    public Font XAxisFont {
+      get { return xAxisFont; }
+      set { xAxisFont = value; }
+    }
+
+    public Color XAxisColor {
+      get { return xAxisColor; }
+      set { xAxisColor = value; }
+    }
+  }
+
+  public delegate void UpdatePropertiesHandler();
+}
Index: /trunk/sources/HeuristicLab.Visualization/TextShape.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/TextShape.cs	(revision 1336)
+++ /trunk/sources/HeuristicLab.Visualization/TextShape.cs	(revision 1337)
@@ -34,4 +34,12 @@
 
       Color = Color.Blue;
+    }
+
+    public TextShape(double x, double y, string text, Font font, Color color) {
+      this.x = x;
+      this.y = y;
+      this.text = text;
+      Font = font;
+      Color = color;
     }
 
Index: /trunk/sources/HeuristicLab.Visualization/XAxis.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/XAxis.cs	(revision 1336)
+++ /trunk/sources/HeuristicLab.Visualization/XAxis.cs	(revision 1337)
@@ -7,4 +7,7 @@
     
     private ILabelProvider labelProvider = new ContinuousLabelProvider("0.####");
+
+    private Color color = Color.Blue;
+    private Font font = new Font("Arial", 8);
 
     public ILabelProvider LabelProvider {
@@ -20,5 +23,5 @@
                                               ClippingArea.X1)) {
         TextShape label = new TextShape(x, ClippingArea.Height - 3,
-                                        labelProvider.GetLabel(x));
+                                        labelProvider.GetLabel(x), Font, Color);
         label.AnchorPositionX = AnchorPositionX.Middle;
         label.AnchorPositionY = AnchorPositionY.Top;
@@ -28,4 +31,14 @@
       base.Draw(graphics);
     }
+
+    public Color Color {
+      get { return color; }
+      set { color = value; }
+    }
+
+    public Font Font {
+      get { return font; }
+      set { font = value; }
+    }
   }
 }