Index: trunk/sources/HeuristicLab.Hive.Client.Communication/WcfService.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Communication/WcfService.cs	(revision 1337)
+++ trunk/sources/HeuristicLab.Hive.Client.Communication/WcfService.cs	(revision 1340)
@@ -89,9 +89,10 @@
         if (Connected != null)
           Connected(this, new EventArgs());                               
-        
+        //Todo: This won't be hit. EVER        
         if (ConnState == NetworkEnum.WcfConnState.Failed)
           ConnectionRestored(this, new EventArgs());        
       }
       catch (Exception ex) {
+        //Todo: Rename to HandleNetworkError
         NetworkErrorHandling(ex);
       }
Index: trunk/sources/HeuristicLab.Hive.Client.Core/Core.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Core/Core.cs	(revision 1337)
+++ trunk/sources/HeuristicLab.Hive.Client.Core/Core.cs	(revision 1340)
@@ -52,9 +52,10 @@
   public class Core: MarshalByRefObject {
     public delegate string GetASnapshotDelegate();
-
+    //Todo: private + getter/setter removen.
     public static Object Locker { get; set; }
-
+    //Todo: ev. Rename to "abortRequested"
     public static bool ShutdownFlag { get; set; }
-
+    
+    //Todo: Access modifier
     Dictionary<long, Executor> engines = new Dictionary<long, Executor>();
     Dictionary<long, AppDomain> appDomains = new Dictionary<long, AppDomain>();
@@ -98,5 +99,6 @@
       MessageQueue queue = MessageQueue.GetInstance();
       
-      //Main processing loop
+      //Main processing loop     
+      //Todo: own thread for message handling
       while (!ShutdownFlag) {
         MessageContainer container = queue.GetMessage();
@@ -112,4 +114,6 @@
     /// <param name="container">The Container, containing the message</param>
     private void DetermineAction(MessageContainer container) {
+      //Todo: Threads aus Threadpool verwenden
+      
       switch (container.Message) {
         //Server requests to abort a job
@@ -152,4 +156,5 @@
     private void GetFinishedJob(object jobId) {
       long jId = (long)jobId;
+      //Todo: Don't return null, throw exception!
       byte[] sJob = engines[jId].GetFinishedJob();
 
@@ -162,4 +167,5 @@
           true);
       } else {
+        //Todo: locking
         JobStorrageManager.PersistObjectToDisc(wcfService.ServerIP, wcfService.ServerPort, jId, sJob);
         AppDomain.Unload(appDomains[jId]);
@@ -219,4 +225,6 @@
     }
 
+    //Todo: Remove intellgent stuff from the async event and move it to the main thread (message queue)
+    //Todo: Seperate this method into 2: Finished jobs and Snapshots
     void wcfService_SendJobResultCompleted(object sender, SendJobResultCompletedEventArgs e) {
       if (e.Result.Success) {        
@@ -237,8 +245,10 @@
         }        
       } else {
+        //Todo: don't Java Style! IT'S EVIL!
         Logging.GetInstance().Error(this.ToString(), "Sending of job " + e.Result.JobId + " failed");
       }
     }
 
+    //Todo: First stop all threads, then terminate
     void wcfService_ServerChanged(object sender, EventArgs e) {
       Logging.GetInstance().Info(this.ToString(), "ServerChanged has been called");
Index: trunk/sources/HeuristicLab.Hive.Client.Core/Heartbeat.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Core/Heartbeat.cs	(revision 1337)
+++ trunk/sources/HeuristicLab.Hive.Client.Core/Heartbeat.cs	(revision 1340)
@@ -73,5 +73,5 @@
       Console.WriteLine("tick");  
       ClientInfo info = ConfigManager.Instance.GetClientInfo();
-      // Todo: remove tempfix for free cores.
+      // Todo: remove tempfix for free cores. Fix spelling of freeCores (uppercase)
 
       HeartBeatData heartBeatData = new HeartBeatData {
Index: trunk/sources/HeuristicLab.Hive.Client.Core/JobStorrage/JobStorrageManager.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Client.Core/JobStorrage/JobStorrageManager.cs	(revision 1337)
+++ trunk/sources/HeuristicLab.Hive.Client.Core/JobStorrage/JobStorrageManager.cs	(revision 1340)
@@ -13,4 +13,6 @@
     
     private static List<JobStorrageInfo> storedJobsList = new List<JobStorrageInfo>();
+    //Todo: execution path
+    //Todo: Choose a better directory name 
     private static String path = "C:\\Program Files\\HeuristicLab 3.0\\plugins\\jobStorrage\\";
     
@@ -19,4 +21,6 @@
 
       JobStorrageInfo info = new JobStorrageInfo { JobID = jobId, ServerIP = serverIP, ServerPort = serverPort, TimeFinished = DateTime.Now };
+      
+      //Todo: Filestream won't be closed if exception occurs
       try {
         Stream jobstream = File.Create(path + filename + ".dat");
@@ -27,4 +31,5 @@
       }
       catch (Exception e) {
+        //Todo: Change to logging.exception!
         Console.WriteLine(e);
       }       
@@ -37,4 +42,6 @@
           Logging.GetInstance().Info("JobStorrageManager", "Sending stored job " + storedJobsList[index-1].JobID + " to the server");
           byte[] job = File.ReadAllBytes(path + filename + ".dat");
+          
+          //Todo: ask server first if he really wants the job...
           ResponseResultReceived res = WcfService.Instance.SendStoredJobResultsSync(ConfigManager.Instance.GetClientInfo().ClientId, storedJobsList[index-1].JobID, job, 1.00, null, true);
           //TODO: has to be fixed from server side
Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/dsHiveServer.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/dsHiveServer.cs	(revision 1337)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/dsHiveServer.cs	(revision 1340)
@@ -14,2 +14,9 @@
     }
 }
+
+namespace dsHiveServerTableAdapters {
+    
+    
+    public partial class HiveUserTableAdapter {
+    }
+}
Index: trunk/sources/HeuristicLab.Hive.Server.Core/ClientCommunicator.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/ClientCommunicator.cs	(revision 1337)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/ClientCommunicator.cs	(revision 1340)
@@ -46,4 +46,5 @@
       new ReaderWriterLockSlim(LockRecursionPolicy.SupportsRecursion);
 
+    // todo: access modifier!
     IClientAdapter clientAdapter;
     IJobAdapter jobAdapter;
@@ -143,4 +144,5 @@
       heartbeatLock.ExitWriteLock();
 
+      // todo: allClients legacy ?
       ICollection<ClientInfo> allClients = clientAdapter.GetAll();
       ClientInfo client = clientAdapter.GetById(clientInfo.ClientId);
@@ -165,4 +167,5 @@
     /// <param name="hbData"></param>
     /// <returns></returns>
+    // todo: new name for "SendHeartBeat" e.g. ProcessHeartBeat
     public ResponseHB SendHeartBeat(HeartBeatData hbData) {
       ResponseHB response = new ResponseHB();