Index: /trunk/sources/HeuristicLab.Visualization/ChartDataRowsModel.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/ChartDataRowsModel.cs	(revision 1340)
+++ /trunk/sources/HeuristicLab.Visualization/ChartDataRowsModel.cs	(revision 1341)
@@ -6,4 +6,5 @@
 using System.Text;
 using HeuristicLab.Visualization.LabelProvider;
+using HeuristicLab.Visualization.Options;
 
 namespace HeuristicLab.Visualization{
@@ -16,4 +17,6 @@
     //private string xAxisLabel;
     private ILabelProvider labelProvider = new ContinuousLabelProvider("0.##");
+
+    private ViewSettings viewSettings = new ViewSettings();
 
     public ILabelProvider XAxisLabelProvider {
@@ -129,4 +132,9 @@
         return max;
       }
+    }
+
+    public ViewSettings ViewSettings {
+      get { return viewSettings; }
+      set { viewSettings = value; }
     }
 
Index: /trunk/sources/HeuristicLab.Visualization/HeuristicLab.Visualization.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/HeuristicLab.Visualization.csproj	(revision 1340)
+++ /trunk/sources/HeuristicLab.Visualization/HeuristicLab.Visualization.csproj	(revision 1341)
@@ -100,5 +100,5 @@
       <DependentUpon>OptionsDialog.cs</DependentUpon>
     </Compile>
-    <Compile Include="Options\ViewPropertiesModel.cs" />
+    <Compile Include="Options\ViewSettings.cs" />
     <Compile Include="PanListener.cs" />
     <Compile Include="LabelProvider\StringLabelProvider.cs" />
Index: /trunk/sources/HeuristicLab.Visualization/IChartDataRowsModel.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/IChartDataRowsModel.cs	(revision 1340)
+++ /trunk/sources/HeuristicLab.Visualization/IChartDataRowsModel.cs	(revision 1341)
@@ -2,4 +2,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Visualization.LabelProvider;
+using HeuristicLab.Visualization.Options;
 
 namespace HeuristicLab.Visualization {
@@ -25,4 +26,6 @@
     int MaxDataRowValues { get; }
 
+    ViewSettings ViewSettings { get; set; }
+
     event ModelChangedHandler ModelChanged;
     event DataRowAddedHandler DataRowAdded;
Index: /trunk/sources/HeuristicLab.Visualization/LineChart.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/LineChart.cs	(revision 1340)
+++ /trunk/sources/HeuristicLab.Visualization/LineChart.cs	(revision 1341)
@@ -19,4 +19,6 @@
     private readonly Dictionary<IDataRow, RowEntry> rowToRowEntry = new Dictionary<IDataRow, RowEntry>();
 
+    private readonly ViewSettings viewSettings;
+
 //    private readonly Stack<RectangleD> clippingAreaHistory = new Stack<RectangleD>();
     private readonly WorldShape userInteractionShape = new WorldShape();
@@ -29,5 +31,4 @@
     private bool zoomToFullView;
 
-    private readonly ViewPropertiesModel viewPropertiesModel;
 
     /// <summary>
@@ -50,6 +51,6 @@
 
       this.model = model;
-      viewPropertiesModel = new ViewPropertiesModel(titleShape.Font, titleShape.Color, legendShape.Font, legendShape.Color, xAxis.Font, xAxis.Color);
-      viewPropertiesModel.OnUpdateProperties += UpdateViewProperties;
+      viewSettings = model.ViewSettings;
+      viewSettings.OnUpdateSettings += UpdateViewProperties;
 
       Item = model;
@@ -62,12 +63,12 @@
 
     private void UpdateViewProperties() {
-      titleShape.Font = viewPropertiesModel.TitleFont;
-      titleShape.Color = viewPropertiesModel.TitleColor;
-
-      legendShape.Font = viewPropertiesModel.LegendFont;
-      legendShape.Color = viewPropertiesModel.LegendColor;
-
-      xAxis.Font = viewPropertiesModel.XAxisFont;
-      xAxis.Color = viewPropertiesModel.XAxisColor;
+      titleShape.Font = viewSettings.TitleFont;
+      titleShape.Color = viewSettings.TitleColor;
+
+      legendShape.Font = viewSettings.LegendFont;
+      legendShape.Color = viewSettings.LegendColor;
+
+      xAxis.Font = viewSettings.XAxisFont;
+      xAxis.Color = viewSettings.XAxisColor;
 
       canvasUI.Invalidate();
@@ -145,5 +146,5 @@
 
     private void optionsToolStripMenuItem_Click(object sender, EventArgs e) {
-      OptionsDialog optionsdlg = new OptionsDialog(this.model, viewPropertiesModel);
+      OptionsDialog optionsdlg = new OptionsDialog(model);
       optionsdlg.ShowDialog(this);
     }
Index: /trunk/sources/HeuristicLab.Visualization/Options/OptionsDialog.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/Options/OptionsDialog.cs	(revision 1340)
+++ /trunk/sources/HeuristicLab.Visualization/Options/OptionsDialog.cs	(revision 1341)
@@ -6,11 +6,11 @@
   public partial class OptionsDialog : Form {
     private readonly IChartDataRowsModel model;
-    private readonly ViewPropertiesModel propertiesModel;
+    private readonly ViewSettings viewSettings;
 
-    public OptionsDialog(IChartDataRowsModel model, ViewPropertiesModel propertiesModel) {
+    public OptionsDialog(IChartDataRowsModel model) {
       InitializeComponent();
 
       this.model = model;
-      this.propertiesModel = propertiesModel;
+      viewSettings = model.ViewSettings;
     }
 
@@ -75,42 +75,42 @@
 
     private void btnChangeTitleFont_Click(object sender, EventArgs e) {
-      fdFont.Font = propertiesModel.TitleFont;
-      fdFont.Color = propertiesModel.TitleColor;
+      fdFont.Font = viewSettings.TitleFont;
+      fdFont.Color = viewSettings.TitleColor;
 
       DialogResult dr = fdFont.ShowDialog();
 
       if(dr == DialogResult.OK) {
-        propertiesModel.TitleFont = fdFont.Font;
-        propertiesModel.TitleColor = fdFont.Color;
+        viewSettings.TitleFont = fdFont.Font;
+        viewSettings.TitleColor = fdFont.Color;
 
-        propertiesModel.UpdateView();
+        viewSettings.UpdateView();
       }
     }
 
     private void btnChangeLegendFont_Click(object sender, EventArgs e) {
-      fdFont.Font = propertiesModel.LegendFont;
-      fdFont.Color = propertiesModel.LegendColor;
+      fdFont.Font = viewSettings.LegendFont;
+      fdFont.Color = viewSettings.LegendColor;
 
       DialogResult dr = fdFont.ShowDialog();
 
       if (dr == DialogResult.OK) {
-        propertiesModel.LegendFont = fdFont.Font;
-        propertiesModel.LegendColor = fdFont.Color;
+        viewSettings.LegendFont = fdFont.Font;
+        viewSettings.LegendColor = fdFont.Color;
 
-        propertiesModel.UpdateView();
+        viewSettings.UpdateView();
       }
     }
 
     private void btnChangeXAxisFont_Click(object sender, EventArgs e) {
-      fdFont.Font = propertiesModel.XAxisFont;
-      fdFont.Color = propertiesModel.XAxisColor;
+      fdFont.Font = viewSettings.XAxisFont;
+      fdFont.Color = viewSettings.XAxisColor;
 
       DialogResult dr = fdFont.ShowDialog();
 
       if (dr == DialogResult.OK) {
-        propertiesModel.XAxisFont = fdFont.Font;
-        propertiesModel.XAxisColor = fdFont.Color;
+        viewSettings.XAxisFont = fdFont.Font;
+        viewSettings.XAxisColor = fdFont.Color;
 
-        propertiesModel.UpdateView();
+        viewSettings.UpdateView();
       }
     }
Index: unk/sources/HeuristicLab.Visualization/Options/ViewPropertiesModel.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/Options/ViewPropertiesModel.cs	(revision 1340)
+++ 	(revision )
@@ -1,61 +1,0 @@
-using System.Drawing;
-
-namespace HeuristicLab.Visualization.Options {
-  public class ViewPropertiesModel {
-    public event UpdatePropertiesHandler OnUpdateProperties;
-
-    private Font titleFont;
-    private Color titleColor;
-    private Font legendFont;
-    private Color legendColor;
-    private Font xAxisFont;
-    private Color xAxisColor;
-
-    public ViewPropertiesModel(Font titleFont, Color titleColor, Font legendFont, Color legendColor, Font xAxisFont, Color xAxisColor) {
-      this.titleFont = titleFont;
-      this.titleColor = titleColor;
-      this.legendFont = legendFont;
-      this.legendColor = legendColor;
-      this.xAxisFont = xAxisFont;
-      this.xAxisColor = xAxisColor;
-    }
-
-    public void UpdateView() {
-      if (OnUpdateProperties != null) {
-        OnUpdateProperties();
-      }
-    }
-
-    public Font TitleFont {
-      get { return titleFont; }
-      set { titleFont = value; }
-    }
-
-    public Color TitleColor {
-      get { return titleColor; }
-      set { titleColor = value; }
-    }
-
-    public Font LegendFont {
-      get { return legendFont; }
-      set { legendFont = value; }
-    }
-
-    public Color LegendColor {
-      get { return legendColor; }
-      set { legendColor = value; }
-    }
-
-    public Font XAxisFont {
-      get { return xAxisFont; }
-      set { xAxisFont = value; }
-    }
-
-    public Color XAxisColor {
-      get { return xAxisColor; }
-      set { xAxisColor = value; }
-    }
-  }
-
-  public delegate void UpdatePropertiesHandler();
-}
Index: /trunk/sources/HeuristicLab.Visualization/Options/ViewSettings.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/Options/ViewSettings.cs	(revision 1341)
+++ /trunk/sources/HeuristicLab.Visualization/Options/ViewSettings.cs	(revision 1341)
@@ -0,0 +1,63 @@
+using System.Drawing;
+
+namespace HeuristicLab.Visualization.Options {
+  public class ViewSettings {
+    public event UpdateViewSettingsHandler OnUpdateSettings;
+
+    private Font titleFont;
+    private Color titleColor;
+    private Font legendFont;
+    private Color legendColor;
+    private Font xAxisFont;
+    private Color xAxisColor;
+
+    public ViewSettings() {
+      titleFont = new Font("Arial", 8);
+      titleColor = Color.Blue;
+
+      legendFont = new Font("Arial", 8);
+      legendColor = Color.Blue;
+
+      xAxisFont = new Font("Arial", 8);
+      xAxisColor = Color.Blue;
+    }
+
+    public void UpdateView() {
+      if (OnUpdateSettings != null) {
+        OnUpdateSettings();
+      }
+    }
+
+    public Font TitleFont {
+      get { return titleFont; }
+      set { titleFont = value; }
+    }
+
+    public Color TitleColor {
+      get { return titleColor; }
+      set { titleColor = value; }
+    }
+
+    public Font LegendFont {
+      get { return legendFont; }
+      set { legendFont = value; }
+    }
+
+    public Color LegendColor {
+      get { return legendColor; }
+      set { legendColor = value; }
+    }
+
+    public Font XAxisFont {
+      get { return xAxisFont; }
+      set { xAxisFont = value; }
+    }
+
+    public Color XAxisColor {
+      get { return xAxisColor; }
+      set { xAxisColor = value; }
+    }
+  }
+
+  public delegate void UpdateViewSettingsHandler();
+}